#!/usr/bin/perl

use DBI;
use Date::Simple ('date', 'today');
use Net::SMTP;

# URL path to enetman server root (no trailing slash)
$enetmanurl = "https://thisurl";
# SMTP server
our $smtpserver = "yoursmtpserver";
our $debug = 0;

#*****************************************************#
# DONT EDIT BELOW THIS LINE ( unless you want to =] ) #
#*****************************************************#

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

$year += 1900;
$mon = $mon+1;
if($mon eq 13) {
	$mon = 1;
}
if(length($mon) eq 1) {
	$mon = "0$mon";
}
if(length($mday) eq 1) {
	$mday = "0$mday";
}

$today = "$year$mon$mday";

$dbh = DBI->connect("DBI:mysql:database=netman;host=localhost","netman", "centerstuff",{'RaiseError' => 1});
$query = $dbh->prepare("SELECT ID,Name,expirationDate,alert,numberofAlerts,alertInterleave,primaryEmailAddresses,escalationEmailAddresses from software WHERE alert != ''");
$query->execute();

while ($result = $query->fetchrow_hashref()) {
	$alert = $result->{'alert'};
	$numberofalerts = $result->{'numberofAlerts'};
	$alertinterleave = $result->{'alertInterleave'};
	$primaryemailaddresses = $result->{'primaryEmailAddresses'};
	#$primaryemailaddresses =~ s/\@/\\\@/;
	$escalationemailaddresses = $result->{'escalationEmailAddresses'};
	#$escalationemailaddresses =~ s/\@/\\\@/;
	$ID = $result->{'ID'};
	$Name = $result->{'Name'};
	$date = $result->{'expirationDate'};
	@date = split("/",$date);
	if(length(@date[0]) eq 1) {
		@date[0] = "0@date[0]";
	}
	if(length(@date[1]) eq 1) {
		@date[1] = "0@date[1]";
	}

	$datealigned = "@date[2]@date[0]@date[1]";

	$alertdate = $datealigned - $alert;

	$n = 0;
	while($n ne $numberofalerts) {
		if($n) {
			$secalertday[$n] = $secalertday[$n-1] + $alertinterleave;
		} else {
			$secalertday[$n] = $alertdate + $alertinterleave;
		}
		$n++;
	}

	$diff = date($datealigned) - date($today);

	if($alertdate eq $today) {
		$content = "This is a first time alert\n\n**********************\nProgram : $Name\nExpiration Date : $date\nExpires In : $diff Days\nLink : $enetmanurl/index.php?page=edit-software.php&view=software&ID=$ID\n**********************\n\n";
		$subject = "Program : $Name | Expiration Date : $date | $diff days left";
	}

	foreach $secalertday(@secalertday) {
		if(($secalertday eq $today) && ($secalertday < $datealigned)){
			$diff = date($datealigned) - date($today);
			$scontent = "This is a repeated alert\n\n**********************\nProgram : $Name\nExpiration Date : $date\nExpires In : $diff Days\nLink : $enetmanurl/index.php?page=edit-software.php&view=software&ID=$ID\n**********************\n\n";
			$subject = "Program : $Name | Expiration Date : $date | $diff days left";
		}
	}

	if($datealigned eq $today) {
		$econtent = "The following license is expired\n\n**********************\nProgram : $Name\nExpiration Date : $date\nLink : $enetmanurl/index.php?page=edit-software.php&view=software&ID=$ID\n**********************\n\n";
		$subject = "Program : $Name | Expiration Date : $date";
	}

	if(($content) || ($scontent)) {
		$body = "Software license are about to expire\n\n$content$scontent";
		@to = split(",",$primaryemailaddresses);
		foreach $to(@to) {
			SendEmail($subject,$body,$to);
		}
	}

	if($scontent) {
		$body = "Software license are about to expire\n\n$scontent";
		@to = split(",",$escalationemailaddresses);
		foreach $to(@to) {
			if($to) {
				SendEmail($subject,$body,$to);
			}
		}
	}

	if($econtent) {
		$body = "The following software licenses have expired\n\n$econtent";
		@to = split(",",$primaryemailaddresses);
		foreach $to(@to) {
			if($to) {
				SendEmail($subject,$body,$to);
			}
		}
		@to = split(",",$escalationemailaddresses);
		foreach $to(@to) {
			if($to) {
				SendEmail($subject,$body,$to);
			}
		}
	}

}

sub SendEmail($subject,$body,$to) {
	if(!$debug) {
		$smtp = Net::SMTP->new($smtpserver);
		$smtp->mail($ENV{USER});
		$smtp->to($to);
		$smtp->data();
		$smtp->datasend("Subject: $subject\n");
		$smtp->datasend("\n");
		$smtp->datasend("$body");
		$smtp->dataend();
		$smtp->quit;
	} else {
		print "\nSMTP Server : $smtpserver\n"; 
		print "To : $to\n";
		print "Subject : $subject\n";
		print $body;
	}
}
